unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ADODB, DB, StdCtrls;

CONST
  (* change this constants with valid values to test *)
  DATABASE_NAME = 'test';
  SERVER_IP     = 'localhost';
  TABLE_NAME    = 'b21578';
  TEXT_FIELDNAME= 'TFld';

type
  TForm1 = class(TForm)
    ADOConnection: TADOConnection;
    ADODataSet: TADODataSet;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure DoShowBug;
Var ADOConnection : TADOConnection;
   ADODataSet : TADOQuery;
begin
  ADOConnection := TADOConnection.Create(Nil);
  try
    ADOConnection.ConnectionString :=
       'Provider=MSDASQL.1;'+
       'Extended Properties="'+
         'USER=root;DATABASE='+DATABASE_NAME+';'+
         'DRIVER={MySQL ODBC 3.51 Driver};'+
         'OPTION=526597;'+ (* Can put 1 or 526596 too *)
         'PORT=3306;'+
         'SERVER='+SERVER_IP+'"';
    (* Delphi will prompt for user name and password *)
    ADOConnection.Connected := True;
    (* Here Delphi connects (if all is ok)
      Now, we will open a simple SELECT query*)
    ADODataSet := TADOQuery.Create(Nil);
    try
      ADODataSet.Connection := ADOConnection;
      ADODataSet.SQL.Text := 'SELECT * FROM '+TABLE_NAME+'e'; //EMPTY
      ADODataSet.open;
        (* If table has no values, then it shows: TMemoField, but if there is
           some value, it shows TStringField *)
      ShowMessage('ClassName of TEXT field (empty tbl): '+ ADODataSet.fieldByName(TEXT_FIELDNAME).ClassName);

      ADODataSet.Close;
      ADODataSet.Connection := ADOConnection;
      ADODataSet.SQL.Text := 'SELECT * FROM '+TABLE_NAME+'f'; //FULL
      ADODataSet.open;
        (* If table has no values, then it shows: TMemoField, but if there is
           some value, it shows TStringField *)
      ShowMessage('ClassName of TEXT field (not empty tbl): '+ ADODataSet.fieldByName(TEXT_FIELDNAME).ClassName);
    finally
      ADODataSet.free;
    end;
  finally
    ADOConnection.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DoShowBug;
end;

end.
